program test_read_GRIB2

  ! a small program to test GRIB fortran interface

  use GribIO, only: init_GRIB_module, dealloc_all_GRIB_messages, &
       xget_field_from_GRIB_file, par_id_t

  implicit none

  character(len=256) :: filename_grib
  integer :: i,j
  integer, parameter :: max_lat_size=160, max_lon_size=320
  real    :: lat_of_first_gridpoint, lat_step
  integer :: nr_lat_points
  real    :: lon_of_first_gridpoint, lon_step
  integer :: nr_lon_points
  real, dimension(1:max_lat_size,1:max_lon_size) :: field

  call init_GRIB_module()

  ! original name of this testfile was: NWP_20031111_12_12_lowres.grib
  filename_grib = "./testfile.grib"
  print '(A)',"retrieve grib field par_id_t"

  ! read grib field into a local array
  call xget_field_from_GRIB_file(filename_grib, par_id_t,&
       max_lat_size, max_lon_size, &
       lat_of_first_gridpoint, lat_step, nr_lat_points, &
       lon_of_first_gridpoint, lon_step, nr_lon_points, &
       field)
  
  ! require the numerical output to be reproducible
  ! with 4 digits accuracy (as tested by the difftool)
  print *,"REALACC(4)"
  print '(A,F8.3)', "lat of first gridpoint = ",lat_of_first_gridpoint
  print '(A,F8.3)', "lat step               = ",lat_step
  print '(A,I8)',   "number of lat points   = ",nr_lat_points
  print '(A,F8.3)', "lon of first gridpoint = ",lon_of_first_gridpoint
  print '(A,F8.3)', "lon step               = ",lon_step
  print '(A,I8)',   "number of lon points   = ",nr_lon_points
  print '(A)', " "
  print '(A)', "    i    j  field(i,j)"

  ! loop over part of the grib field
  do i = max_lat_size/2, max_lat_size/2+3
    do j = max_lon_size/2, max_lon_size/2+3
      print '(2I5,F12.3)', i, j, field(i,j)
    enddo
  enddo
  print *,'ENDREALACC'
  
  call dealloc_all_GRIB_messages()

end program test_read_GRIB2
