program test_read_GRIB3

  ! a small program to test GRIB fortran interface

  use GribIO, only: init_GRIB_module, dealloc_all_GRIB_messages, &
       xgrib_get_date, xgrib_get_time, par_id_10u, par_id_10v, &
       xget_from_grib_file, xget_field_from_grib_file

  implicit none

  character(len=256) :: filename_grib
  real    :: dummy
  integer :: time, date
  integer :: i,j
  integer, parameter :: max_lat_size=50, max_lon_size=50
  real    :: lat_of_first_gridpoint, lat_step
  integer :: nr_lat_points
  real    :: lon_of_first_gridpoint, lon_step
  integer :: nr_lon_points
  real, dimension(max_lat_size,max_lon_size) :: field

  call init_GRIB_module()

  dummy = 0.

  ! original name of this testfile was: NWP_20031111_12_12_lowres.grib
  filename_grib = "./testfile.grib"
  print '(A)',"retrieve grib field par_id_10u"

  time = nint(xget_from_GRIB_file(filename_grib, xgrib_get_time, dummy, par_id_10u))
  date = nint(xget_from_GRIB_file(filename_grib, xgrib_get_date, dummy, par_id_10v))
  print '(A,I11)',"date of grib field = ",date
  print '(A,I11)',"time of grib field = ",time

  ! read grib field into a local array
  call xget_field_from_GRIB_file(filename_grib, par_id_10u,&
       max_lat_size, max_lon_size, &
       lat_of_first_gridpoint, lat_step, nr_lat_points, &
       lon_of_first_gridpoint, lon_step, nr_lon_points, &
       field)

  ! require the numerical output to be reproducible
  ! with 4 digits accuracy (as tested by the difftool)
  print *,'REALACC(4)'
  print '(A)', " "
  print '(A)', "    i    j  field(i,j)"

  ! loop over part of the grib field
  do i = 48, 50
    do j = 48, 50
      print '(2I5,F12.3)', i, j, field(i,j)
    enddo
  enddo

  print *,"ENDREALACC"
  
  call dealloc_all_GRIB_messages()

end program test_read_GRIB3
